<?php

namespace Intuit\Models;

use Illuminate\Support\Arr;
use Jenssegers\Model\Model;

use Intuit\Traits\CompareAttributes;

/*
  +"Customer": {#1760
    +"Taxable": false
    +"BillAddr": {#1758
      +"Id": "2"
      +"Line1": "25 Stone Drive"
      +"City": "Sydney"
      +"CountrySubDivisionCode": "NSW"
      +"PostalCode": "2001"
      +"Lat": "-33.737492"
      +"Long": "151.195909"
    }
    +"Job": false
    +"BillWithParent": false
    +"Balance": 1650.0
    +"BalanceWithJobs": 1650.0
    +"CurrencyRef": {#1761
      +"value": "AUD"
      +"name": "Australian Dollar"
    }
    +"PreferredDeliveryMethod": "None"
    +"IsProject": false
    +"domain": "QBO"
    +"sparse": false
    +"Id": "1"
    +"SyncToken": "0"
    +"MetaData": {#1762
      +"CreateTime": "2018-02-21T20:02:17-08:00"
      +"LastUpdatedTime": "2018-03-22T13:36:42-07:00"
    }
    +"GivenName": "Adwin"
    +"FamilyName": "Ko"
    +"FullyQualifiedName": "Adwin Ko"
    +"CompanyName": "Ko International Ltd"
    +"DisplayName": "Adwin Ko"
    +"PrintOnCheckName": "Adwin Ko"
    +"Active": true
  }
  +"time": "2022-08-13T21:15:37.254-07:00"
 */

final class Customer extends Model
{
	use CompareAttributes;

	public function __get($key) {
		$keymap = [
			'id' => 'Id',
			'synctoken' => 'SyncToken',
			'active' => 'Active',
			'companyname' => 'CompanyName',
			'fullname' => 'FullyQualifiedName',
			'ref' => 'ResaleNum',
		];

		switch ($key) {
			case 'created_at':
				return object_get($this->getAttribute('MetaData'),'CreateTime');
			case 'updated_at':
				return object_get($this->getAttribute('MetaData'),'LastUpdatedTime');
			case 'email':
				return object_get($this->getAttribute('PrimaryEmailAddr'),'Address');

			default:
				return parent::__get(Arr::get($keymap,$key,$key));
		}
	}
}