<?php

namespace Intuit\Models;

use Illuminate\Support\Arr;
use Jenssegers\Model\Model;

use Intuit\Traits\CompareAttributes;

/*
	{#2052
        +"Name": "GST"
        +"Description": "GST"
        +"Active": true
        +"Hidden": false
        +"Taxable": true
        +"TaxGroup": true
        +"SalesTaxRateList": {#2053
          +"TaxRateDetail": array:1 [
            0 => {#2054
              +"TaxRateRef": {#2055
                +"value": "23"
                +"name": "GST (sales)"
              }
              +"TaxTypeApplicable": "TaxOnAmount"
              +"TaxOrder": 0
            }
          ]
        }
        +"PurchaseTaxRateList": {#2056
          +"TaxRateDetail": []
        }
        +"TaxCodeConfigType": "SYSTEM_GENERATED"
        +"domain": "QBO"
        +"sparse": false
        +"Id": "14"
        +"SyncToken": "0"
        +"MetaData": {#2057
          +"CreateTime": "2023-05-10T01:05:41-07:00"
          +"LastUpdatedTime": "2023-05-10T01:05:41-07:00"
        }
      }
 */

final class Taxcode extends Model
{
	use CompareAttributes;

	public function __get($key) {
		$keymap = [
			'id' => 'Id',
			'synctoken' => 'SyncToken',
			'name' => 'Name',
		];

		switch ($key) {
			case 'created_at':
				return object_get($this->getAttribute('MetaData'),'CreateTime');
			case 'updated_at':
				return object_get($this->getAttribute('MetaData'),'LastUpdatedTime');

			default:
				return parent::__get(Arr::get($keymap,$key,$key));
		}
	}
}